/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.utils;

import lombok.experimental.UtilityClass;
import org.bukkit.Material;
import org.bukkit.block.data.BlockData;

import java.util.HashMap;
import java.util.Map;

@UtilityClass
public class PlaceItemWrapper {
    public static final Map<Material, Material> ITEM_MATERIAL_TO_BLOCK_MATERIAL = new HashMap<>();
    public static final Map<Material, Material> BLOCK_MATERIAL_TO_WALL_BLOCK_MATERIAL = new HashMap<>();

    static {
        for (Material material : Material.values()) {
            if (!material.isBlock()) continue;
            if (material.isLegacy()) continue;
            BlockData blockData = material.createBlockData();
            Material placementMaterial = blockData.getPlacementMaterial();
            if (material == placementMaterial) continue;
            if (placementMaterial == Material.AIR) continue;
            if (placementMaterial.isItem() && !placementMaterial.isBlock()) {
                ITEM_MATERIAL_TO_BLOCK_MATERIAL.put(placementMaterial, material);
            }
            if (material.name().contains("WALL")) {
                BLOCK_MATERIAL_TO_WALL_BLOCK_MATERIAL.put(placementMaterial, material);
            }
        }
    }
}
